## hsc 0.934

=== Makefile ===
#
# Makefile for hsc ("html sucks completely")
#
# Copyright (C) 1995-1998  Thomas Aglassinger
# Copyright (C) 2001-2003 Matthias Bethke
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

CC	= gcc
SYS	= -DUNIX
CFLAGS = -fomit-frame-pointer -O3 -Wall -pedantic
#CFLAGS = -ggdb -g3 -DDEBUG -DDEBUG_UGLY -DDEBUG_UGLY_MEMORY -Wall -pedantic -lefence
#CFLAGS = -ggdb -Wall -pedantic

# Link statically against dietlibc. Might be faster for you, though slightly
# bigger than the dynamic glibc version
#CC	= diet gcc -nostdinc

#------------------------------------------------
#
# These symbols are only needed if you use the
# `install' rule:
#
# INSTALL       `install' command to be used
# INSTDIR       base destination-directory 
#               ("/bin" and "/lib" will be added)
#
#------------------------------------------------
INSTALL         = install
#INSTALL	= /bin/install

#INSTDIR         = /usr
INSTDIR	= /usr/local
#INSTDIR	= $(HOME)

#------------------------------------------------
#
# Windows NT/2000/XP, Visual C++ 6.0
#
# NOTES: 
#  - also change "COMP" below, otherwise linking will fail
#  - ignore the link-errors (making the makefile use *.obj 
#    instead of *.o would be more trouble)
#  - use 'nmake' to build hsc.exe
#  - 'nmake install' doesn't work.
#
#------------------------------------------------
#CC	= cl
#CFLAGS	= -Ox -nologo
#SYS	= -DWINNT

#------------------------------------------------
#
# NeXTStep
#
#------------------------------------------------
#CC	= cc
#CFLAGS	=
#SYS	= -DNEXTSTEP

#------------------------------------------------
#
# AmigaOS with ixemul.library
#
#------------------------------------------------
#CC	= gcc
#CFLAGS	= -m68020-40 -Wall -W -pedantic -Wno-unused -O2 -s \
#	-fstrength-reduce -fbaserel	
#SYS	= -DUNIX -UAMIGA

#------------------------------------------------
#
# BeOS
#
#------------------------------------------------
#CC	= mwcc
#CFLAGS	= -ansi off -char unsigned -dialect c
#SYS	= -DBEOS 

#------------------------------------------------
#
# AmigaOS with PowerUp (experimental)
#
#------------------------------------------------
#CC	= vc
#CFLAGS	= -Iugly
#SYS	= -DAMIGA

#------------------------------------------------
#
# AROS crosscompiling
#
#------------------------------------------------
#CC	= /usr/local/aros-sdk/bin/i386-aros-gcc
#CFLAGS = -Wall -pedantic -s -O3
#SYS	= -DAROS

#------------------------------------------------
#
# Unixoid Systems
#
# Try to guesstimate the values that might work 
# with your system and compiler.
#
#------------------------------------------------

#------------------------------------------------
# this one should usually work
#
#CC	= cc
#CFLAGS	=
#SYS	= -DUNIX

#------------------------------------------------
# this one should also work and even optimise
#
#CC	= cc
#CFLAGS	= -O
#SYS	= -DUNIX

#------------------------------------------------
# create a debugging version
#
#CC	= cc
#CFLAGS	= -DDEBUG -DDEBUG_UGLY
#SYS	= -DUNIX

#------------------------------------------------
# works with gcc
#
#CC	= gcc
#CFLAGS = -DDEBUG -DDEBUG_UGLY
#CFLAGS = -O2
#SYS	= -DUNIX

#------------------------------------------------
# create a debugging version for gcc and gdb
#
#CC	= gcc
#CFLAGS	= -DDEBUG -DDEBUG_UGLY -ggdb
#SYS	= -DUNIX

#--------------------------------------------------------------------
# avoid fooling around below this line
#--------------------------------------------------------------------

.PHONY: all docs clean all_clean sterile depend ckx

# use this line for Visual C++ 6.0:
#COMP	= $(CC) -Fo$@ $(SYS) -I. -c

# use this line for other platforms:
COMP	= $(CC) -o $@ $(SYS) -I.

LINK	= $(CC) -o $@ $(SYS) -I.
MOVE	= mv
COPY	= cp
DELETE	= rm -f
DELETEALL= rm -Rf

#--------------------------------------------------------------------
# do not touch anything below this line
#--------------------------------------------------------------------

PROJECT_DIRS = amiga hsc hsclib hscprj hsctools riscos ugly
DEPENDENCIES = .deps
#
# symbols for objects and executables
#
OBJ_TOOLS	= ugly/umemory.o ugly/ustring.o ugly/unikot.o ugly/expstr.o \
		ugly/fname.o ugly/dllist.o ugly/ufile.o ugly/uargs.o \
		ugly/ustrlist.o ugly/infile.o ugly/prginfo.o \
		hscprj/document.o hscprj/license.o hscprj/project.o \
		hscprj/readprj.o hscprj/writeprj.o

OBJ_HSC		= $(OBJ_TOOLS) \
		hsclib/lmessage.o hsclib/entity.o hsclib/tag.o hsclib/attrib.o \
		hsclib/idref.o hsclib/hscprc.o hsclib/lstatus.o hsclib/input.o \
		hsclib/skip.o hsclib/uri.o hsclib/eval.o hsclib/posteval.o \
		hsclib/defattr.o hsclib/deftag.o hsclib/css.o hsclib/parse.o \
		hsclib/include.o hsclib/linit.o hsclib/size.o hsclib/tag_misc.o \
		hsclib/tag_a.o hsclib/tag_hsc.o hsclib/tag_if.o \
		hsclib/tag_macro.o hsclib/tcpip.o \
		hsc/global.o hsc/status.o hsc/callback.o hsc/args.o \
		hsc/output.o hsc/hsc.o
OBJ_DEPP	= hsctools/hscdepp.o
OBJ_PITT	= hsctools/hscpitt.o
OBJ_ALL		= $(OBJ_HSC)
EXE_ALL		= hsc/hsc hsctools/hscdepp hsctools/hscpitt

#
# compile all tools
#
all : $(EXE_ALL) docs

# implict rule for object-files
# (old-style implicit rule)
.c.o :
	$(COMP)  $(CFLAGS) -c $<

hsc/hsc : $(OBJ_HSC)
	$(LINK) $(OBJ_HSC) $(CFLAGS)

hsctools/hscdepp : $(OBJ_TOOLS) $(OBJ_DEPP)
	$(LINK) $(OBJ_DEPP) $(OBJ_TOOLS) $(CFLAGS)

hsctools/hscpitt : $(OBJ_TOOLS) $(OBJ_PITT)
	$(LINK) $(OBJ_PITT) $(OBJ_TOOLS) $(CFLAGS)

#--------------------------------------------------------------------
# installation
#--------------------------------------------------------------------
install : all
	strip $(EXE_ALL)
	$(INSTALL) -m 755 -s hsc/hsc $(INSTDIR)/bin/hsc
	$(INSTALL) -m 755 -s hsctools/hscdepp $(INSTDIR)/bin/hscdepp
	$(INSTALL) -m 755 -s hsctools/hscpitt $(INSTDIR)/bin/hscpitt
	$(INSTALL) -m 644 hsc.prefs $(INSTDIR)/lib/hsc.prefs
	$(INSTALL) -m 644 -D README $(INSTDIR)/share/doc/hsc/README
	$(INSTALL) -m 644 -D CHANGES $(INSTDIR)/share/doc/hsc/CHANGES
	cp -R docs $(INSTDIR)/share/doc/hsc/
	find $(INSTDIR)/share/doc/hsc/docs -type d | xargs chmod 755
	find $(INSTDIR)/share/doc/hsc/docs -type f | xargs chmod 644

#--------------------------------------------------------------------
# cleanup - remove all objects and executables
#--------------------------------------------------------------------
clean :
	$(DELETE) $(EXE_ALL) $(foreach d,$(PROJECT_DIRS),$(wildcard $(d)/*.o))

sterile : clean
	find . -name tags | xargs $(DELETE)
	$(DELETEALL) docs/*
	find . -name .nautilus-metafile.xml -or -name .thumbnails | xargs $(DELETE)

#--------------------------------------------------------------------
# compile the doumentation
#--------------------------------------------------------------------
docs:
	PATH=$(shell pwd)/hsc:$(PATH) HSCEXTRAOPTS="IGNORE=21" make -C docs-source

#--------------------------------------------------------------------
# update dependencies
#--------------------------------------------------------------------
depend: $(DEPENDENCIES)

$(DEPENDENCIES):
	$(DELETE) $@
	for d in amiga hsc hsclib hscprj hsctools riscos ugly; do \
		for f in `ls $$d/*.c`; do \
			gcc -DUNIX -I. -MM "$$f" | \
			sed -e "s/^\w\+\.o:/$$d\/&/" >>$@; \
		done; \
	done


include .deps

=== docs-source/Makefile ===
#
# Makefile for the hsc manual
#

#
# DESTDIR  - destination directory (relative)
# IGNORE   - messages to be ignored
# PRJFILE  - project file
# STDINC   - standard includes for all sources
# HSCMISC  - miscellaneous flags and options
# 
# HSC      - shell command that invokes hsc
# HSCFLAGS - hsc options
#
# HSCDEPP  - shell command to invoke hscdepp
# HSCPITT  - shell command to invoke hscpitt
#

#
# To compile the whole manual unders non-Amiga-OS, you have to perform the 
# following steps before the Unix parent directories are treated correctly
# by this Makefile:
#
# - Go to the part where the dependencies created by hscdepp start (quite 
#   at the end of this file) and replace all " /" by " /../". Note the
#   blanks at the biginning of these two search/replace expressions.
# - Activate the "PARENT = ../" symbol below.
# - In the shell, enter "hscpitt new" to clear the project file
# - For your convenience, change the IGNORE symbol below to
#   "IGNORE = ign=46 ign=51" as the project data can not yet be
#   validated by hsc.
#

#PARENT	= /
PARENT	= ../

DESTDIR = $(PARENT)docs/
IGNORE  =ign=46 ign=51
PRJFILE =hsc.project
STDINC  =inc/macro.hsc inc/webpage.hsc
HSCMISC	=rplcent getsize compact msgmode=pedantic prefsfile=$(PARENT)hsc.prefs quotestyle=double maxmsg=0 maxerr=0 lowercasetags

HSCFLAGS=$(HSCMISC) $(IGNORE) $(STDINC) $(HSCEXTRAOPTS) status=quiet
HSC	=hsc

HSCDEPP =hscdepp
HSCPITT =hscpitt

.PHONY: all all_hsc depend rebuild

#
# rule to update whole docs
#
all : dirs images all_hsc

#
# pattern rule for html-files
#
# The lines below will do the following:
# - View name of document currently processing
# - Create html-document
# - Validate document just created using CheckHTML 
#
# If the symbols `PS' has been defined, a version prepared for
# html2ps will be created.
#
$(DESTDIR)%.html : %.hsc
ifdef PS
	@echo ps:$@
	@$(HSC) inc/ps.hsc   $(HSCFLAGS) to=$(DESTDIR) $<
else
ifdef VERBOSE
	$(HSC) inc/html.hsc $(HSCFLAGS) to=$(DESTDIR) prjfile=$(PRJFILE) $<
	chmod ugo+r $<
else
	@echo $@
	@$(HSC) inc/html.hsc $(HSCFLAGS) to=$(DESTDIR) prjfile=$(PRJFILE) $<
	@chmod ugo+r $<
endif
endif
#	@CheckHTML $@ QUIET

#
# update dependencies
#
depend :
	$(HSCDEPP) file=Makefile prjfile=$(PRJFILE) verbose

#
# rebuild all documents
#
rebuild :
	$(MAKE) -W inc/macro.hsc

#
# rebuild PostScript-version
#
rebuild_ps :
	$(MAKE) -W inc/macro.hsc PS=1

#
# create PostScript documentation
#
ps :
	ksh -c "perl /bin/html2ps -W l -f html2ps.config -o ../../hsc.ps ../docs/index.html"
#	ksh -c "perl /bin/html2ps -O -f html2ps.config -o ../../hsc.ps ../docs/features/getsize.html"

# Create all destination directories
dirs:
	for d in `find * -type d`; do test -d $(DESTDIR)$$d || mkdir $(DESTDIR)$$d; done

# Copy images over to destination if required
IMAGES=$(addprefix $(DESTDIR), $(wildcard image/*))

$(IMAGES): $(DESTDIR)image/%: image/%
	cp $< $@

images: $(IMAGES)

# --- DO NOT MODIFY THIS LINE -- hsc-dependencies follow ---

# dependencies updated: Thursday 03-Apr-2003 01:36:36

all_hsc : ../docs/distrib.html ../docs/macro/flag.html \
    ../docs/macro/flag.html ../docs/macro/flag.html ../docs/macro/flag.html \
    ../docs/macro/flag.html ../docs/macro/attrib.html \
    ../docs/macro/flag.html ../docs/questions.html ../docs/macro/flag.html \
    ../docs/options.html ../docs/message-list.html \
    ../docs/message-list.html ../docs/message-list.html \
    ../docs/message-list.html ../docs/options.html \
    ../docs/macro/attrib.html ../docs/macro/flag.html ../docs/index.html \
    ../docs/questions.html ../docs/features/expressions.html \
    ../docs/about.html ../docs/project/make.html ../docs/examples.html \
    ../docs/future.html ../docs/copy.html ../docs/project/hscpitt.html \
    ../docs/features/getsize.html ../docs/features/strip.html \
    ../docs/teutsch.html ../docs/others.html ../docs/install.html \
    ../docs/features/if.html ../docs/source.html ../docs/features/exec.html \
    ../docs/features/syntax.html ../docs/features/assign.html \
    ../docs/features/spcattr.html ../docs/ports.html ../docs/envvar.html \
    ../docs/message-list.html ../docs/options.html ../docs/fileargs.html \
    ../docs/macro/attrib.html ../docs/features/rplcent.html \
    ../docs/features/uris.html ../docs/project/prjfile.html \
    ../docs/project/index.html ../docs/features/checkuri.html \
    ../docs/macro/macros.html ../docs/macro/flag.html \
    ../docs/features/prefs.html ../docs/features/spctags.html \
    ../docs/messages.html ../docs/bugs.html ../docs/project/hscpaltrow.html \
    ../docs/related.html ../docs/updates.html ../docs/project/makefile.html \
    ../docs/require.html ../docs/usecases.html ../docs/author.html \
    ../docs/index.html ../docs/questions.html ../docs/changes.html \
    ../docs/project/hscdepp.html ../docs/features/expressions.html \
    ../docs/undocumented.html ../docs/features/css.html

../docs/distrib.html : distrib.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/attrib.html : macro/attrib.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/questions.html : questions.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/options.html : options.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/message-list.html : message-list.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/message-list.html : message-list.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/message-list.html : message-list.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/message-list.html : message-list.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/options.html : options.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/attrib.html : macro/attrib.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/index.html : index.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/questions.html : questions.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/features/expressions.html : features/expressions.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/about.html : about.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/project/make.html : project/make.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/examples.html : examples.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/future.html : future.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/copy.html : copy.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/project/hscpitt.html : project/hscpitt.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/features/getsize.html : features/getsize.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/features/strip.html : features/strip.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/teutsch.html : teutsch.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/others.html : others.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/install.html : install.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/features/if.html : features/if.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/source.html : source.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/features/exec.html : features/exec.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc exmpl/exec.hsc exmpl/exec.hsc

../docs/features/syntax.html : features/syntax.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/features/assign.html : features/assign.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/features/spcattr.html : features/spcattr.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc exmpl/anchor.hsc exmpl/anchor.hsc

../docs/ports.html : ports.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/envvar.html : envvar.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/message-list.html : message-list.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/options.html : options.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/fileargs.html : fileargs.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/macro/attrib.html : macro/attrib.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/features/rplcent.html : features/rplcent.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/features/uris.html : features/uris.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/project/prjfile.html : project/prjfile.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/project/index.html : project/index.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/features/checkuri.html : features/checkuri.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/macro/macros.html : macro/macros.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc exmpl/macro_addr.hsc exmpl/macro_addr.hsc \
    exmpl/macro_file.hsc exmpl/macro_cntnest.hsc exmpl/macro_cntnest.hsc \
    exmpl/macro_cnt2nest.hsc exmpl/macro_cnt2nest.hsc exmpl/macro_next.hsc \
    exmpl/macro_next.hsc exmpl/macro_locale.hsc exmpl/macro_locale.hsc

../docs/macro/flag.html : macro/flag.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/features/prefs.html : features/prefs.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/features/spctags.html : features/spctags.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/messages.html : messages.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/bugs.html : bugs.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/project/hscpaltrow.html : project/hscpaltrow.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/related.html : related.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/updates.html : updates.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/project/makefile.html : project/makefile.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/require.html : require.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/usecases.html : usecases.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/author.html : author.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/index.html : index.hsc inc/html.hsc inc/macro.hsc inc/webpage.hsc

../docs/questions.html : questions.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/changes.html : changes.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc ../CHANGES

../docs/project/hscdepp.html : project/hscdepp.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/features/expressions.html : features/expressions.hsc inc/html.hsc \
    inc/macro.hsc inc/webpage.hsc

../docs/undocumented.html : undocumented.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

../docs/features/css.html : features/css.hsc inc/html.hsc inc/macro.hsc \
    inc/webpage.hsc

# --- DO NOT MODIFY THIS LINE -- hsc-dependencies precede ---

=== riscos/Makefile ===
#
# Makefile for hsc ("html sucks completely")
#
# Copyright (C) 1994,95,96  Thomas Aglassinger
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#====================================================================
#
# This Makefile should work on most Unixoid systems, but no
# optimisation is performed. Feel free to fool around with the
# compiler-flags.
#
# (1) Use "make -f Makefile.dodl" to compile.
#
# (2) Copy "hsc/hsc", "hsctools/hscdepp" and "hsctools/hscpitt" to
#     anywhere in your search-path.
#
# (3) Use "make -f Makefile.dodl sterile" for a total cleanup. Maybe
#     you also have to pass an option to make to ignore the
#     return-code of the "rm"-command; usually, this is "-i".
#
# (4) Read the docs, section "Installation" what to do with
#     "hsc.prefs".
#
# IMPORTANT: Don't forget to hit the return-key after typing commands
#            in the shell!
#

#------------------------------------------------
# this one should always work
#
#CC	= cc
#CFLAGS	=

#------------------------------------------------
# this one should also work and even optimise
#
CC	= cc
CFLAGS	= -Otime

#------------------------------------------------
# create a debugging version
#
#CC	= cc
#CFLAGS	= -DDEBUG -DDEBUG_UGLY -g

#------------------------------------------------
# works with gcc
#
#CC	= gcc
#CFLAGS = -s -O2

#------------------------------------------------
# create a debugging version for gcc and gdb
#
#CC	= gcc
#CFLAGS	= -DDEBUG -DDEBUG_UGLY -ggdb

#--------------------------------------------------------------------
# avoid fooling around below this line
#--------------------------------------------------------------------

SYS	= -DRISCOS -throwback
COMP	= $(CC) -o $@ $(SYS) -I. -c
LINK	= link -o $@
MOVE	= rename
COPY	= copy
DELETE	= wipe
SQUEEZE = squeeze

#--------------------------------------------------------------------
# do not touch anything below this line
#--------------------------------------------------------------------

#
# symbols for objects and executables
#
OBJ_TOOLS	= ugly.o.all_ugly hscprj.o.all_hscp riscos.o.unixname riscos.o.UnixStubs
OBJ_HSC		= $(OBJ_TOOLS) hsclib.o.all_hscl hsc.o.all_hsc
OBJ_ALL		= $(OBJ_HSC)
EXE_ALL		= hsc.all_hsc hsctools.all_depp hsctools.all_pitt

#
# compile all tools
#
all : $(EXE_ALL)

# implict rule for object-files
# (old-style implicit rule)
.c.o :
	$(COMP) $*.c $(CFLAGS)

hsc/all_hsc : $(OBJ_HSC)
	$(LINK) $(OBJ_HSC) $(CMODE)
	$(SQUEEZE) hsc.all_hsc ^.hsc

hsctools/all_depp : $(OBJ_TOOLS) hsctools.o.all_depp
	$(LINK) hsctools.o.all_depp $(OBJ_TOOLS) $(CMODE)
	$(SQUEEZE) hsctools.all_depp ^.hscdepp

hsctools/all_pitt : $(OBJ_TOOLS) hsctools.o.all_pitt
	$(LINK) hsctools.o.all_pitt $(OBJ_TOOLS) $(CMODE)
	$(SQUEEZE) hsctools.all_pitt ^.hscpitt

### UnixName stuff ###
riscos/unixname.o: riscos/unixname.c riscos/unixname.h

#
# cleanup - remove all objects and executables
#
clean :
	create hsc.o.void 0
	wipe hsc.o.* V~C
	create hsctools.o.void 0
	wipe hsctools.o.* V~C
	create hsclib.o.void 0
	wipe hsclib.o.* V~C
	create hscprj.o.void 0
	wipe hscprj.o.* V~C
	create ugly.o.void 0
	wipe ugly.o.* V~C
	wipe riscos.o.unixname V~C

all_clean :
	$(DELETE) $(OBJ_ALL) $(EXE_ALL)

sterile : clean all_clean
	$(DELETE) hsc/hsc
	$(DELETE) hsctools/hscdepp
	$(DELETE) hsctools/hscpitt

#
# the dependencies below are created using `MkDepend' by Lars Dning,
# available from amient:dev/c/MkDepend.lha
#

# --- DO NOT MODIFY THIS LINE -- AUTO-DEPENDS FOLLOW ---
hsc/all_hsc.o : hsc/args.c hsc/callback.c hsc/global.c hsc/hsc.c \
    hsc/output.c hsc/status.c hsc/global.h hsc/status.h hscprj/license.h \
    ugly/fname.h ugly/prginfo.h ugly/returncd.h ugly/uargs.h \
    amiga/msgbrowser.c hsc/callback.h hsc/output.h riscos/msgbrowser.c \
    hsclib/hsclib.h hsc/args.h hsc/hsc_rev.h hscprj/project.h \
    riscos/unixname.h hsc/hdebug.h ugly/dllist.h ugly/expstr.h \
    ugly/infile.h ugly/umemory.h ugly/ustring.h ugly/utypes.h ugly/expstr.h \
    ugly/utypes.h ugly/umemory.h hsclib/inc_base.h hsclib/include.h \
    hsclib/linit.h ugly/dllist.h ugly/udebug.h hsclib/attrib.h \
    hsclib/entity.h hsclib/hscprc.h hsclib/ldebug.h hsclib/lmessage.h \
    hsclib/lstatus.h hsclib/msgid.h hsclib/tag.h hscprj/document.h

hsclib/all_hscl.o : hsclib/tag_macro.c hsclib/tag_if.c hsclib/tag_hsc.c \
    hsclib/tag_a.c hsclib/tag_misc.c hsclib/size.c hsclib/linit.c \
    hsclib/include.c hsclib/parse.c hsclib/deftag.c hsclib/defattr.c \
    hsclib/posteval.c hsclib/eval.c hsclib/uri.c hsclib/skip.c \
    hsclib/input.c hsclib/lstatus.c hsclib/hscprc.c hsclib/idref.c \
    hsclib/attrib.c hsclib/tag.c hsclib/entity.c hsclib/lmessage.c \
    ugly/ustring.h ugly/infile.h ugly/umemory.h ugly/expstr.h ugly/dllist.h \
    ugly/utypes.h hsclib/msgid.h hsclib/ldebug.h hsclib/parse.h \
    hsclib/include.h hsclib/deftag.h hsclib/defattr.h hsclib/inc_tagcb.h \
    hsclib/skip.h hsclib/eval.h hsclib/tag_if.h hsclib/tag_macro.h \
    hsclib/uri.h ugly/fname.h hscprj/document.h hsclib/inc_base.h \
    hsclib/tag_misc.h hsclib/tag_hsc.h hsclib/tag_a.h hsclib/input.h \
    ugly/ufile.h hsclib/size.h hscprj/project.h hsclib/posteval.h \
    hsclib/idref.h ugly/returncd.h ugly/ustrlist.h hsclib/tag.h \
    hsclib/entity.h ugly/utypes.h ugly/dllist.h ugly/expstr.h ugly/udebug.h \
    hsclib/hscprc.h hsclib/lstatus.h hsclib/lmessage.h hsclib/attrib.h \
    ugly/ustring.h

hscprj/all_hscp.o : hscprj/writeprj.c hscprj/readprj.c hscprj/project.c \
    hscprj/license.c hscprj/document.c hscprj/project.h hscprj/document.h \
    ugly/ustring.h ugly/infile.h ugly/umemory.h ugly/expstr.h ugly/dllist.h \
    ugly/utypes.h hscprj/pdefs.h hscprj/pdebug.h hsclib/ldebug.h \
    ugly/utypes.h ugly/dllist.h ugly/expstr.h ugly/udebug.h

hsctools/all_depp.o : hsctools/hscdepp.c hscprj/license.h hscprj/project.h \
    hscprj/document.h ugly/returncd.h ugly/prginfo.h ugly/uargs.h \
    ugly/infile.h ugly/expstr.h ugly/dllist.h ugly/ustring.h \
    hsctools/depp_rev.h ugly/umemory.h ugly/utypes.h hsclib/ldebug.h \
    ugly/umemory.h ugly/utypes.h ugly/dllist.h ugly/expstr.h ugly/udebug.h

hsctools/all_pitt.o : hsctools/hscpitt.c hscprj/license.h hscprj/project.h \
    hscprj/document.h ugly/returncd.h ugly/prginfo.h ugly/ustrlist.h \
    ugly/uargs.h ugly/infile.h ugly/expstr.h ugly/dllist.h ugly/ustring.h \
    hsctools/pitt_rev.h ugly/umemory.h ugly/utypes.h hsclib/ldebug.h \
    ugly/dllist.h ugly/ustring.h ugly/utypes.h ugly/umemory.h ugly/expstr.h \
    ugly/udebug.h

ugly/all_ugly.o : ugly/prginfo.c ugly/infile.c ugly/ustrlist.c ugly/uargs.c \
    ugly/ufile.c ugly/dllist.c ugly/fname.c ugly/expstr.c ugly/ustring.c \
    ugly/umemory.c ugly/udebug.h ugly/utypes.h ugly/umemory.h ugly/infile.h \
    ugly/fname.h ugly/ustring.h ugly/expstr.h ugly/ustrlist.h \
    ugly/args_hlp.c ugly/args_prp.c ugly/args_set.c ugly/args_fre.c \
    ugly/uargs.h ugly/dllist.h ugly/ufile.h ugly/udebug.h

# --- DO NOT MODIFY THIS LINE -- AUTO-DEPENDS PRECEDE ---

# Dynamic dependencies:
o.unixname:	c.unixname
o.unixname:	h.unixname

=== starter-project/Makefile ===
#
# Generic Makefile for hsc projects
#

#
# DESTDIR    - destination directory (usually relative to source directory)
# HSCMESSAGE - hsc message options
# HSCPROJECT - project file
# HSCINCLUDE - standard includes for all sources
# HSCMISC    - miscellaneous flags and options
# 
# HSC        - shell command that invokes hsc
# HSCFLAGS   - hsc options
#
# HSCDEPP    - shell command that invokes hscdepp
#

DESTDIR	=
HSCMESSAGE	=MsgMode=normal Ignore=46
HSCPROJECT	=hsc.project
HSCINCLUDE	=include/standard.hsc include/page.hsc
HSCMISC	=RplcEnt

HSC	=hsc
HSCFLAGS=$(HSCMISC) $(HSCMESSAGE) PrjFile=$(HSCPROJECT) to=$(DESTDIR) $(HSCINCLUDE)

HSCDEPP	=hscdepp

#
# rule to update whole docs
# (all_hsc will be created by hscdepp)
#
all : all_hsc

#
# implicit rule for html-files
#
$(DESTDIR)%.html : %.hsc
	$(HSC) $(HSCFLAGS) $<

#
# update dependencies
#
depend :
	$(HSCDEPP) file=Makefile PrjFile=$(HSCPROJECT) verbose

=== examples/fetzenschaedl/Makefile ===
#
# makefile for hsc example project
#

#
# NOTE: this makefile is prepared for use under AmigaOS (default) and
#	Unix. To enable the Unix-version, enable the second 
#	definition of the symbol `HSC'.
#

#
# command used to envoke hsc
#
HSC	= //hsc
#HSC	= ../../hsc

#
# options for hsc
#
HSCOPTS   = TO= STATUS="line|verbose"

all : stupid.html hugo/hugo.html main.html 

main.html : main.hsc macro.hsc
	$(HSC) $(HSCOPTS) main.hsc 

stupid.html : stupid.hsc macro.hsc
	$(HSC) $(HSCOPTS) stupid.hsc 

hugo/hugo.html : hugo/hugo.hsc macro.hsc
	$(HSC) $(HSCOPTS) hugo/hugo.hsc 

# EOF

=== examples/simple/source_hsc/Makefile ===
#
# makefile for hsc example project
#

#
# NOTE: this makefile is prepared for use under AmigaOS (default) and
#	Unix. To enable the Unix-version, enable the second 
#	definition of the symbol "HSC" and "DESTDIR".
#

#
# command used to invoke hsc
#
HSC	= ///hsc
#HSC	= ../../../hsc

#
# project destination dir
#
DESTDIR	= /object_html/
#DESTDIR	= ../object_html/

#
# options for hsc
#
HSCOPTS   = TO=$(DESTDIR) STATUS="line|verbose"

all : $(DESTDIR)stupid.html $(DESTDIR)hugo/hugo.html $(DESTDIR)main.html 

$(DESTDIR)main.html : main.hsc macro.hsc
 	$(HSC) $(HSCOPTS) main.hsc 

$(DESTDIR)stupid.html : stupid.hsc macro.hsc
	$(HSC) $(HSCOPTS) stupid.hsc 

$(DESTDIR)hugo/hugo.html : hugo/hugo.hsc macro.hsc
	$(HSC) $(HSCOPTS) hugo/hugo.hsc 

# EOF

## hsc 1.0b

=== src/regex/test/Makefile ===
# Generated automatically from Makefile.in by configure.
# Makefile for regex testing.
# 
# Copyright (C) 1992 Free Software Foundation, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

CPPFLAGS =
CFLAGS = -g
LDFLAGS =

srcdir = .
VPATH = .:../.

CC = gcc
DEFS =  -DSTDC_HEADERS=1 -DHAVE_STRING_H=1 -DHAVE_ALLOCA_H=1
LIBS =  $(LOADLIBES)

ETAGS = etags
SHELL = /bin/sh

debug = -DDEBUG
ALL_CPPFLAGS = -I. -I$(srcdir) -I../$(srcdir) $(DEFS) $(CPPFLAGS) $(debug)

.c.o:
	$(CC) $(ALL_CPPFLAGS) $(CFLAGS) -c $<


# Define this as `../regex.o' to get the optimized version.
regex_o = dregex.o
test_h = test.h
test_o = test.o bsd-interf.o other.o tregress.o psx-basic.o psx-extend.o \
         psx-generic.o psx-group.o psx-interf.o psx-interv.o
common_o = printchar.o upcase.o xmalloc.o $(malloc)

# We have a lot of mallocs we can try when we run afoul of strange bugs.
malloc = 
#malloc = # the libc malloc
#malloc = g++malloc.o
#malloc = debugmalloc.o
#malloc = emacsmalloc.o
emacsmallocflags = -Drcheck -Dbotch=abort -DUSG

# default is to do nothing.
default:

all: regex syntax

regex: $(regex_o) $(common_o) $(test_o) main.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LIBS)

# As long as we're doing tests, we enable debugging.
dregex.o: ../regex.c ../regex.h
	rm -f $@
	$(CC) $(ALL_CPPFLAGS) $(CFLAGS) -c ../$(srcdir)/regex.c
	mv regex.o $@

# iregex is the interactive regex.
iregex: $(common_o) $(regex_o) iregex.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LIBS)

# fileregex searches for an r.e. in every line of a given file.
fileregex_o = fileregex.o printchar.o $(regex_o)
fileregex: $(fileregex_o)
	$(CC) -o $@ $(LDFLAGS) $(fileregex_o) $(LIBS)

# cppregex is regex with a preprocessed regex.c.  Useful when the
# problem is inside some macro.
cppregex: regexcpp.o $(common_o) $(test_o) main.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LIBS)

regexcpp.o: regexcpp.c 

regexcpp.c: regex.c regexcpp.sed
	rm -f regexcpp.c
	$(CC) -E $(ALL_CPPFLAGS) ../$(srcdir)/regex.c \
          | egrep -v '^#|^ *$$' \
          | sed -f regexcpp.sed \
          > regexcpp.c
	chmod a-w regexcpp.c

# Have to give this malloc special flags.
emacsmalloc.o: emacsmalloc.c
	$(CC) -c $(CFLAGS) $(ALL_CPPFLAGS) $(emacsmallocflags) \
	  ../$(srcdir)/test/emacsmalloc.c

syntax: syntax.o
	$(CC) $(CFLAGS) -o $@ syntax.o

syntax.c: syntax.skel bits
	sed '/\[\[\[replace.*\]\]\]/r bits' syntax.skel > $@

bits: regex.h
	sed -n 1,/RE_SYNTAX_EMACS/p ../$(srcdir)/regex.h \
          | grep "#define RE_.*1" \
          | sed 's/^#define \(RE_[A-Z_]*\) .*/  TEST_BIT (\1);/' > $@

check: regex
	./regex

TAGS: regex.c regex.h *.h *.c
	$(ETAGS) -t $^

depend:
	gcc -MM $(ALL_CPPFLAGS) *.c > /tmp/depend
.PHONY: depend

install:
.PHONY: install

clean mostlyclean:
	rm -f *.o regex cppregex iregex fileregex regexcpp.c syntax

distclean: clean
	rm -f bits syntax.c Makefile

extraclean: distclean
	rm -f *~* *\#* patch* *.orig *.rej *.bak core a.out

realclean: distclean
	rm -f TAGS

Makefile: Makefile.in ../config.status
	(cd ..; sh config.status)

# Prevent GNU make 3 from overflowing arg limit on system V.
.NOEXPORT:

# Assumes $(distdir) is the place to put our files.
distfiles = ChangeLog TAGS *.in *.c *.h regexcpp.sed syntax.skel
dist: Makefile TAGS
	mkdir $(distdir)
	ln $(distfiles) $(distdir)

# Automatically-generated dependencies below here.
alloca.o : alloca.c 
bsd-interf.o : bsd-interf.c 
debugmalloc.o : debugmalloc.c 
emacsmalloc.o : emacsmalloc.c getpagesize.h 
fileregex.o : fileregex.c .././regex.h 
g++malloc.o : g++malloc.c //usr/include/stdio.h getpagesize.h 
iregex.o : iregex.c .././regex.h 
main.o : main.c test.h .././regex.h 
malloc-test.o : malloc-test.c 
other.o : other.c test.h .././regex.h 
printchar.o : printchar.c 
psx-basic.o : psx-basic.c test.h .././regex.h 
psx-extend.o : psx-extend.c test.h .././regex.h 
psx-generic.o : psx-generic.c test.h .././regex.h 
psx-group.o : psx-group.c test.h .././regex.h 
psx-interf.o : psx-interf.c test.h .././regex.h 
psx-interv.o : psx-interv.c test.h .././regex.h 
syntax.o : syntax.c .././regex.h 
test.o : test.c test.h .././regex.h 
tregress.o : tregress.c test.h .././regex.h 
upcase.o : upcase.c 
xmalloc.o : xmalloc.c

=== debian/changelog ===
hsc (1.0b-0ubuntu1) xenial; urgency=medium

  * New upstream release.
  * debian/watch: Create, along with pgpsigurlmangle.
  * debian/upstream/signing-key.asc: Add upstream signing key.
  * debian/rules:
    - Convert to minimal dh sequencer.
    - Use dh-autotools_dev.
  * debian/compat: Indicate compatibility level of 9.
  * debian/control:
    - Build-depend on debhelper (>= 9) and autotools-dev.
    - Add Homepage field.
    - Bump Standards-Version to 3.9.6.
  * debian/source/format: Indicate 3.0 (quilt) format.
  * debian/copyright: Switch to DEP-5 format.
  * debian/patches:
    - destdir.patch: Use DESTDIR so that files are installed correctly.
    - isblank.patch: Use upstream patch to fix static redefinition.
    - pref_path.patch: Adapt existing patch to also change Makefile.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 08 Dec 2015 01:02:38 -0500

hsc (0.934-1ubuntu2) gutsy; urgency=low

  * debian/control: Update maintainer fields according to debian-
    maintainer-field spec.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 15 Aug 2007 08:05:26 +0000

hsc (0.934-1ubuntu1) breezy; urgency=low

  * It's Build-Depends, not Build-Depends-Indep, if "debian/rules build"
    requires it.

 -- LaMont Jones <lamont@ubuntu.com>  Sat,  3 Sep 2005 20:52:22 -0600

hsc (0.934-1) unstable; urgency=low

  * Initial Release.

 -- Lorenzo Martignoni <lorenzo.martignoni@poste.it>  Fri, 20 Feb 2004 13:26:26 +0100

=== debian/control ===
Source: hsc
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Lorenzo Martignoni <lorenzo.martignoni@poste.it>
Build-Depends: debhelper (>= 9), autotools-dev
Standards-Version: 3.9.6
Homepage: https://github.com/mbethke/hsc

Package: hsc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: html sucks completely, a developer tool for HTML projects
 It can be used on any HTML file and creates a new HTML file as output. In the
 input file, you may use an extended syntax based on HTML, which allows for
 things like macros, conditionals, variables, expressions etc.
 .
 It is mainly intended for creating and maintaining larger HTML projects.
 As a commandline tool, it can be used together with `make', and a
 dependency generator is included.
 .
 Hsc is not a tool to make HTML easier for beginners; it's a tool
 to make HTML a bit less painful and brain-damaged for people who
 already know how to work with it.

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ http://towiski.de/binaries/hsc-(.+).tar.bz2
